﻿using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace WCFServiceWebRole1
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the interface name "IService1" in both code and config file together.
    [ServiceContract]
    public interface IService1
    {

        [OperationContract]
        int Add(int a, int b);

        [OperationContract]
        int Divide(int a, int b);

        [OperationContract]
        string GetTextFile(string filename);

        // Illegal: Two methods with identical names
        [OperationContract]
        double Add2(double a, double b);

        [OperationContract]
        int OneUp(ref int a);

        [OperationContract]
        int TwoThings(int a, out int b);

        [OperationContract]
        int SumArray(int[] numbers);

        [OperationContract]
        int SumArrayList(ArrayList numbers);

        [OperationContract]
        int SumList(List<int> numbers);

        [OperationContract]
        int SumLinkedList(LinkedList<int> numbers);

        [OperationContract]
        int SumDictionary(IDictionary<string, int> dictionary);

        [OperationContract]
        Student SameStudent(Student student);

        [OperationContract]
        int CountStudents(IList<Student> students);

        [OperationContract]
        void SetState(int state);

        [OperationContract]
        int GetState();

    }

   [DataContract]
    public class Student
    {
        [DataMember]
        public string Name { get; set; }

        [DataMember]
        public int Age { get; set; }
    }
}
