﻿using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace WCFServiceWebRole1
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    // NOTE: In order to launch WCF Test Client for testing this service, please select Service1.svc or Service1.svc.cs at the Solution Explorer and start debugging.
    public class Service1 : IService1
    {
        public int Add(int a, int b)
        {
            return a + b;
        }

        public int Divide(int a, int b)
        {
            return a / b;
        }

        public string GetTextFile(string filename)
        {
            using (FileStream stream = new FileStream(filename, FileMode.Open))
            {
                StreamReader reader = new StreamReader(stream);
                return reader.ReadToEnd();
            }
        }

        public double Add2(double a, double b)
        {
            return a + b;
        }

        public int OneUp(ref int a)
        {
            a++;
            return a;
        }

        public int TwoThings(int a, out int b)
        {
            a++;
            b = a;
            return b;
        }

        public int SumArray(int[] numbers)
        {
            return numbers.Sum();
        }

        public int SumArrayList(ArrayList numbers)
        {
            int result = 0;
            foreach (object obj in numbers)
            {
                result += (int)obj;
            }
            return result;

        }

        public int SumList(List<int> numbers)
        {
            return numbers.Sum();
        }

        public int SumLinkedList(LinkedList<int> numbers)
        {
            return numbers.Sum();
        }

        public int SumDictionary(IDictionary<string, int> dictionary)
        {
            return dictionary.Values.Sum();
        }

        public Student SameStudent(Student student)
        {
            student.Age++;
            return student;
        }

        public int CountStudents(IList<Student> students)
        {
            return students.Count;
        }

        private static int _state;

        public void SetState(int st)
        {
            _state = st;
        }

        public int GetState()
        {
            return _state;
        }
    }
}
